import BaseLayer from '../core/BaseLayer';
import type { ICanvasLayerOptions } from '../core/interface';
import type { CanvasModelType } from './models';
import { CanvasModel } from './models';
export default class CanvasLayer extends BaseLayer<ICanvasLayerOptions> {
    type: string;
    layerModel: CanvasModel;
    protected getDefaultConfig(): Partial<ICanvasLayerOptions>;
    buildModels(): Promise<void>;
    getModelType(): CanvasModelType;
    draw(draw: ICanvasLayerOptions['draw']): this;
    getLayerConfig(): any;
    render(): this;
    getCanvas(): HTMLCanvasElement | null;
    show(): this;
    hide(): this;
    destroy(): void;
}
