import type { IModel, IModelUniform } from '@antv/l7-core';
import BaseModel from '../../core/BaseModel';
export default class ImageModel extends BaseModel {
    protected get attributeLocation(): {
        readonly POSITION: 0;
        readonly POSITION_64LOW: 1;
        readonly COLOR: 2;
        readonly PICKING_COLOR: 3;
        readonly STROKE: 4;
        readonly OPACITY: 5;
        readonly OFFSETS: 6;
        readonly ROTATION: 7;
        readonly MAX: 8;
    } & Record<string, number> & {
        MAX: 8;
        SIZE: number;
        UV: number;
    };
    private texture;
    getUninforms(): IModelUniform;
    protected getCommonUniformsInfo(): {
        uniformsArray: number[];
        uniformsLength: number;
        uniformsOption: {
            [key: string]: any;
        };
    };
    initModels(): Promise<IModel[]>;
    clearModels(): void;
    buildModels(): Promise<IModel[]>;
    protected registerBuiltinAttributes(): void;
    private updateTexture;
}
