import type { IModel, ITexture2D } from '@antv/l7-core';
import BaseModel from '../../core/BaseModel';
export default class RasterModel extends BaseModel {
    protected get attributeLocation(): {
        readonly POSITION: 0;
        readonly POSITION_64LOW: 1;
        readonly COLOR: 2;
        readonly PICKING_COLOR: 3;
        readonly STROKE: 4;
        readonly OPACITY: 5;
        readonly OFFSETS: 6;
        readonly ROTATION: 7;
        readonly MAX: 8;
    } & Record<string, number> & {
        MAX: 8;
        UV: number;
    };
    protected texture: ITexture2D;
    protected colorTexture: ITexture2D;
    getUninforms(): {
        [x: string]: any;
    };
    protected getCommonUniformsInfo(): {
        uniformsArray: number[];
        uniformsLength: number;
        uniformsOption: {
            [key: string]: any;
        };
    };
    private getRasterData;
    initModels(): Promise<IModel[]>;
    buildModels(): Promise<IModel[]>;
    clearModels(): void;
    protected registerBuiltinAttributes(): void;
}
