"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createPlugins = createPlugins;
var _DataMappingPlugin = _interopRequireDefault(require("./DataMappingPlugin"));
var _DataSourcePlugin = _interopRequireDefault(require("./DataSourcePlugin"));
var _FeatureScalePlugin = _interopRequireDefault(require("./FeatureScalePlugin"));
var _LayerAnimateStylePlugin = _interopRequireDefault(require("./LayerAnimateStylePlugin"));
var _LayerMaskPlugin = _interopRequireDefault(require("./LayerMaskPlugin"));
var _LayerModelPlugin = _interopRequireDefault(require("./LayerModelPlugin"));
var _LayerStylePlugin = _interopRequireDefault(require("./LayerStylePlugin"));
var _LightingPlugin = _interopRequireDefault(require("./LightingPlugin"));
var _MultiPassRendererPlugin = _interopRequireDefault(require("./MultiPassRendererPlugin"));
var _PixelPickingPlugin = _interopRequireDefault(require("./PixelPickingPlugin"));
var _RegisterStyleAttributePlugin = _interopRequireDefault(require("./RegisterStyleAttributePlugin"));
var _ShaderUniformPlugin = _interopRequireDefault(require("./ShaderUniformPlugin"));
var _UpdateModelPlugin = _interopRequireDefault(require("./UpdateModelPlugin"));
var _UpdateStyleAttributePlugin = _interopRequireDefault(require("./UpdateStyleAttributePlugin"));
// import ConfigSchemaValidationPlugin from './ConfigSchemaValidationPlugin';

function createPlugins() {
  return [new _DataSourcePlugin.default(), new _RegisterStyleAttributePlugin.default(), new _FeatureScalePlugin.default(), new _DataMappingPlugin.default(), new _LayerStylePlugin.default(), new _LayerMaskPlugin.default(), new _UpdateStyleAttributePlugin.default(), new _UpdateModelPlugin.default(), new _MultiPassRendererPlugin.default(), new _ShaderUniformPlugin.default(), new _LayerAnimateStylePlugin.default(), new _LightingPlugin.default(), new _PixelPickingPlugin.default(), new _LayerModelPlugin.default()];
}