import type { IAnimateOption, IAttribute, IElements, IModel, IModelUniform } from '@antv/l7-core';
import BaseModel from '../../core/BaseModel';
export default class RadarModel extends BaseModel {
    protected get attributeLocation(): {
        readonly POSITION: 0;
        readonly POSITION_64LOW: 1;
        readonly COLOR: 2;
        readonly PICKING_COLOR: 3;
        readonly STROKE: 4;
        readonly OPACITY: 5;
        readonly OFFSETS: 6;
        readonly ROTATION: 7;
        readonly MAX: 8;
    } & Record<string, number> & {
        MAX: 8;
        SIZE: number;
        EXTRUDE: number;
    };
    protected getCommonUniformsInfo(): {
        uniformsArray: number[];
        uniformsLength: number;
        uniformsOption: {
            [key: string]: any;
        };
    };
    getAnimateUniforms(): IModelUniform;
    getAttribute(): {
        attributes: {
            [attributeName: string]: IAttribute;
        };
        elements: IElements;
    };
    initModels(): Promise<IModel[]>;
    buildModels(): Promise<IModel[]>;
    protected animateOption2Array(option: Partial<IAnimateOption>): number[];
    protected registerBuiltinAttributes(): void;
}
