import type { IModel, IModelUniform, IRenderOptions, ITexture2D } from '@antv/l7-core';
import BaseModel from '../../core/BaseModel';
export default class WindModel extends BaseModel {
    protected get attributeLocation(): {
        readonly POSITION: 0;
        readonly POSITION_64LOW: 1;
        readonly COLOR: 2;
        readonly PICKING_COLOR: 3;
        readonly STROKE: 4;
        readonly OPACITY: 5;
        readonly OFFSETS: 6;
        readonly ROTATION: 7;
        readonly MAX: 8;
    } & Record<string, number> & {
        MAX: 8;
        UV: number;
    };
    protected texture: ITexture2D;
    private colorModel;
    private wind;
    private imageCoords;
    private sizeScale;
    private frequency;
    private cacheZoom;
    render(options: Partial<IRenderOptions>): void;
    getUninforms(): IModelUniform;
    initModels(): Promise<IModel[]>;
    getWindSize(): {
        imageWidth: number;
        imageHeight: number;
    };
    buildModels(): Promise<IModel[]>;
    clearModels(): void;
    protected registerBuiltinAttributes(): void;
    private getZoomScale;
    private drawWind;
    private drawColorMode;
}
